/*===========================================
        GRRLIB (GX version) 3.0 alpha
        Code     : NoNameNo
        GX hints : RedShade

        Template Code (Minimum Requirement)
============================================*/
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <math.h>
#include <ogcsys.h>
#include <gccore.h>
#include <wiiuse/wpad.h>
#include <fat.h>
#include <unistd.h>
#include <sys/dir.h>
#include "GRRLIB/GRRLIB.h"
#include "GRRLIB/fonts/GRRLIB_font1.h"
#include "pointer.h"
#include "icon.h"

Mtx GXmodelView2D;

struct LLNode{
	char key;
	struct LLNode *next;
};

struct LLNode *initLLNode(char val);

int caps1(int buttonswitch);
int caps2(int buttonswitch);

int main(){
    fatInitDefault();
	VIDEO_Init();
    WPAD_Init();
	WPAD_SetDataFormat(WPAD_CHAN_0, WPAD_FMT_BTNS_ACC_IR);
    GRRLIB_InitVideo();
    GRRLIB_Start();
    u8 *tex_font1=GRRLIB_LoadTexture(GRRLIB_font1);
	u8 *tex_pointer=GRRLIB_LoadTexture(pointer);
	u8 *tex_icon=GRRLIB_LoadTexture(icon);
	//keyboard display
    int caps =0;

	char keypressed [5];
	strcpy (keypressed, "\0");
    int buttonswitch = 0;
	int cursor = 0;
	int f = 0;
	int p = 0;
	char c1;
	int printcount=0;
	int k = 0;
	int fileopened = 0;
	int home = 0;
	char val;
	char line [ 128 ];
	struct LLNode *head=NULL;
	struct LLNode *curr=NULL;
	struct LLNode *oldstart=NULL;	
	struct LLNode *newstart=NULL;
	struct LLNode *test=NULL;
	int printcount2 = 0;
    int coursercount = 0;
    int filecount = 0;
    int filebatch = 0;
    int fileskip = 0;
    char pathname[MAXPATHLEN];
    struct stat st;
    char filename[MAXPATHLEN];
    chdir ("/");
	getcwd(pathname,MAXPATHLEN);
	char shortfile[20];
	head=initLLNode('\0');

	while(1){
		WPAD_ScanPads();
        u32 wpaddown = WPAD_ButtonsDown(0);
		u32 wpadheld = WPAD_ButtonsHeld(0);
		//calculate coordinants of cursor
		ir_t  ir;
		WPAD_IR(WPAD_CHAN_0, &ir);
		int tx = ir.x;		
		int ty = ir.y;
		tx = round(tx) ;
		ty = round(ty) ;
		//end get coordinantes

		//calculate keyboard button over
		int kbx = 0;
		int kby = 0;
		//file selector
		printcount2 = 0;
		filecount = 0;
		fileskip = 0;
		GRRLIB_FillScreen(0xFF000000);
		if (fileopened == 0){
			GRRLIB_DrawImg(256, 69, 128, 48, tex_icon, 0, 1, 1, 255 );
			GRRLIB_Rectangle(100,360,440,40,0xFF1589FF,1);
			GRRLIB_Printf(110,367,tex_font1,0xFFFFFFFF,2," Select Text File to Edit");
			GRRLIB_Printf(110,387,tex_font1,0xFFFFFFFF,2,"    Press Home to Exit");
			DIR_ITER* dir = diropen (pathname);
			if (filebatch == 0 ){
				GRRLIB_Printf(150,147,tex_font1,0xFFFFFFFF,2,"[..]");
				while ((dirnext(dir, filename, &st) == 0) && (filecount < 8)){
					//st.st_mode & S_IFDIR indicates a directory
					strcpy(shortfile, "");
					strncat(shortfile, filename, 18);
					GRRLIB_Printf(150,(167 + (printcount2*20)),tex_font1,0xFFFFFFFF,2,"%s: %s\n", (st.st_mode & S_IFDIR ? " DIR" : "FILE"), shortfile);
					printcount2++;
					filecount++;
			    }
			}else{
				dirreset (dir);
				GRRLIB_Printf(150,147,tex_font1,0xFFFFFFFF,2,"(BACK)");
				while (fileskip < (8*filebatch)){ 
					dirnext(dir, filename, &st);
					fileskip++;
				}	
				while ((dirnext(dir, filename, &st) == 0) && (filecount < 8)){
				//st.st_mode & S_IFDIR indicates a directory
					strcpy(shortfile, "");
					strncat(shortfile, filename, 18);
					GRRLIB_Printf(150,(167 + (printcount2*20)),tex_font1,0xFFFFFFFF,2,"%s: %s\n", (st.st_mode & S_IFDIR ? " DIR" : "FILE"), shortfile);
					printcount2++;
					filecount++;
				}
			}	
			if (dirnext(dir, filename, &st) == 0){
				filecount++;
				GRRLIB_Printf(150,327,tex_font1,0xFFFFFFFF,2,"(MORE)");
			}		
			if (coursercount > 0) GRRLIB_Printf(120,(147 + ((coursercount-1)*20)),tex_font1,0xFFFFFF00,2,"*");
		} 	
		//end print file selector
		
		//file selector cursor
		if (fileopened == 0){
			if ((tx > 100) && (tx < 490)){
				int cursorloop2 = 1;
				while (cursorloop2 < 11){ 
					if ((ty >(((cursorloop2-1)*20)+90)) && (ty <(((cursorloop2-1)*20)+110))){
						if (cursorloop2 < (filecount+2)){
							coursercount = cursorloop2;
						}else{
							coursercount = 0;
						}    
					}
					cursorloop2++;
				}
			}else{
			coursercount = 0;
			}
		}
	//end file selector cursor
		if (caps != 0){
			int kxl=0;
			for(kxl=0;kxl<4;kxl++){		
				if ((ty>(233+(kxl*30)))&&(ty<(263+(kxl*30)))) kbx = (kxl + 1);
			}					
			int kyl=0;
			for(kyl=0;kyl<12;kyl++){
				if ((tx>((-16)+(kyl*48)))&&(tx<(32+(kyl*48)))) kby = (kyl + 1);
			}
		}
        
		
		if (fileopened == 1){
			curr=head;
			chdir("/");
			chdir(pathname);
			FILE *inFile = fopen(filename, "r");
			while ( fgets ( line, sizeof line, inFile ) != NULL ){
				int j = 0;	
				for(j=0;j<strlen(line);j++){ 
					val = line[j];
					curr->next=initLLNode(val);
					curr=curr->next;
				}
			}
			oldstart=head;
			fileopened = 2;
			home = 1;
			caps = 1;
			fclose(inFile);
		}
		
		if (home == 2){
			GRRLIB_Rectangle(170,80,300,80,0xFFFF0000,1);
			GRRLIB_Printf(210,117,tex_font1,0xFFFFFFFF,4,"CAUTION!");
			GRRLIB_Rectangle(40,200,560,90,0xFF1589FF,1);
			GRRLIB_Printf(65,227,tex_font1,0xFFFFFFFF,2," Press A to Save Changes to File");
			GRRLIB_Printf(65,257,tex_font1,0xFFFFFFFF,2,"   B to Cancel or HOME to Exit");
		}
		
		//print file out of nodes
		if (caps!=0){
			curr=oldstart;
			f = 0;
			p = 0;
			printcount=0;
			k = 0;
			if (strlen(keypressed) != 0){
				for(k=0;k<cursor;k++){		
					curr=curr->next;
				}		
				c1 = keypressed[0];
				test=curr->next;
				curr->next=initLLNode(c1);
				curr=curr->next;
				curr->next=test;
				strcpy (keypressed, "\0");
				cursor++;
			}
			curr=oldstart;
			curr=curr->next;
			while((curr)&&(p<11)){
				if (cursor == printcount){
					GRRLIB_Line((33+(f*20)),(33+(p*20)),(33+(f*20)),(52+(p*20)),0xFFFFFF00);
				}
				if(curr->key == '\n'){
					GRRLIB_Rectangle((39+(f*20)),(38+(p*20)),11,10,0xFFFFFF00,0);
					p++;
					f = 0;
					printcount++;
				}else{
					GRRLIB_Printf((40+(f*20)),(40+(p*20)),tex_font1,0xFFFFFFFF,2,"%c", curr->key);
					f++;
					printcount++;
					if (f == 28){
						f = 0;
						p++;
					}
				}
				if (cursor == printcount) GRRLIB_Line((33+(f*20)),(33+(p*20)),(33+(f*20)),(52+(p*20)),0xFFFFFF00);
				newstart=curr;
				curr=curr->next;
			}
			if (cursor > printcount) cursor=printcount;
		}	
		if (caps == 1){
			GRRLIB_Printf(50,290,tex_font1,0xFFFFFFFF,2,"1  2  3  4  5  6  7  8  9  0  -  =");
			GRRLIB_Printf(50,320,tex_font1,0xFFFFFFFF,2,"q  w  e  r  t  y  u  i  o  p  [  ]");
			GRRLIB_Printf(50,350,tex_font1,0xFFFFFFFF,2,"a  s  d  f  g  h  j  k  l  ;  '  \\");
			GRRLIB_Printf(50,380,tex_font1,0xFFFFFFFF,2,"z  x  c  v  b  n  m  ,  .  /  `  Sp");
			GRRLIB_Rectangle(20,420,610,20,0xFF1589FF,1);
			GRRLIB_Printf(30,427,tex_font1,0xFFFFFFFF,2,"1=DeleteNext (-)=DeleteLast B=CapsLock");
		}
		if (caps == 2){
			GRRLIB_Printf(50,290,tex_font1,0xFFFFFFFF,2,"!  @  #  $  %%  ^  &  *  (  )  _  +");
			GRRLIB_Printf(50,320,tex_font1,0xFFFFFFFF,2,"Q  W  E  R  T  Y  U  I  O  P  {  }");
			GRRLIB_Printf(50,350,tex_font1,0xFFFFFFFF,2,"A  S  D  F  G  H  J  K  L  :  \"  |");
			GRRLIB_Printf(50,380,tex_font1,0xFFFFFFFF,2,"Z  X  C  V  B  N  M  <  >  ?  ~  En");
			GRRLIB_Rectangle(20,420,610,20,0xFF1589FF,1);
			GRRLIB_Printf(30,427,tex_font1,0xFFFFFFFF,2,"1=DeleteNext (-)=DeleteLast B=CapsLock");
		}
		if (caps != 0){
			int xline=0;
			for(xline=0;xline<5;xline++){		
				GRRLIB_Line(32,(278+(xline*30)),609,(278+(xline*30)),0xFFFFFFFF);
			}					
			int yline=0;
			for(yline=0;yline<13;yline++){
				GRRLIB_Line((32+(yline*48)),278,(32+(yline*48)),398,0xFFFFFFFF);
			}
		}
		//print key over
		if ((kbx != 0) && (kby != 0)) GRRLIB_Rectangle((33+((kby-1)*48)),((279+((kbx-1)*30))),46,28,0xFFFFFF00,0);
			
		//print cursor
		if ((tx != 0) || (ty != 0)) GRRLIB_DrawImg(tx, ty, 96, 96, tex_pointer, ir.angle, 1, 1, 255 );
		
		if ((home == 2)&&(wpaddown & WPAD_BUTTON_A)){
			curr=head->next;
			chdir("/");
			chdir(pathname);
			FILE *outFile = fopen(filename, "w");
			while(curr){
				fputc(curr->key, outFile);
				curr=curr->next;
			}
			fclose(outFile);
			GRRLIB_Stop();
			exit(0);
		}
		
		
		if ((caps == 1)&&(wpaddown & WPAD_BUTTON_A)&&(kbx!=0)&&(kby!=0)){
			buttonswitch = ((kbx*100)+kby);
			strcpy (keypressed, caps1(buttonswitch));
		}
		if ((caps == 2)&&(wpaddown & WPAD_BUTTON_A)&&(kbx!=0)&&(kby!=0)){
			buttonswitch = ((kbx*100)+kby);
			strcpy (keypressed, caps2(buttonswitch));
		}
		
		if ((wpaddown & WPAD_BUTTON_B)&&(caps!=0)){
			if (caps == 1){
				caps = 2;
			}else if (caps == 2){
				caps = 1;
			}
		}
		if ((wpaddown & WPAD_BUTTON_DOWN)&&(caps!=0)){
			cursor = 0;
			oldstart=newstart;
		}        
		if ((wpaddown & WPAD_BUTTON_UP)&&(caps!=0)){
			cursor = 0;
			oldstart=head;
		}
		if ((wpadheld & WPAD_BUTTON_RIGHT)&&(caps!=0)){
			if (cursor < printcount) cursor++;
		}  
		if ((wpaddown & WPAD_BUTTON_LEFT)&&(caps!=0)){
			if (cursor > 0) cursor = cursor - 1;
		} 
		if ((wpaddown & WPAD_BUTTON_1)&&(caps!=0)){
			curr=oldstart;
			for(k=0;k<cursor;k++){		
				curr=curr->next;
			}		
			test=curr->next;
			test=test->next;
			curr->next=test;
			
		}
		if ((wpaddown & WPAD_BUTTON_MINUS)&&(caps!=0)){
		    if (cursor > 0){
				cursor = cursor - 1;
				curr=oldstart;
				for(k=0;k<cursor;k++){		
					curr=curr->next;
				}		
				test=curr->next;
				test=test->next;
				curr->next=test;
			}
			
		}
		if ((wpadheld & WPAD_BUTTON_B)&&(home==2)){
			home=1;
			caps=1;
		}  
		if ((wpaddown & WPAD_BUTTON_A)&&(fileopened == 0)){
			if (coursercount == 10){
				filebatch++;
				coursercount = 0;
			}else if (coursercount == 1){
				if (filebatch != 0){
					filebatch--;
					coursercount = 0;
				}else{
					coursercount = 0;
					chdir ("..");
					getcwd(pathname,MAXPATHLEN);
				}
			}else{
				DIR_ITER* dir2 = diropen (pathname);
				fileskip = 0;
				while (fileskip < ((filebatch*8)+(coursercount-1))){ 
					dirnext(dir2, filename, &st);
					fileskip++;
				}
				if (st.st_mode & S_IFDIR){
					filebatch = 0;
					coursercount = 0;
					dirclose (dir2);
					chdir (filename);
					getcwd(pathname,MAXPATHLEN);
				}else{
					fileopened = 1;
				}
			}
		}
		if (wpaddown & WPAD_BUTTON_HOME){
			if (home==1){
				caps = 0;
				home = 2;
			}else{
				GRRLIB_Stop();
				exit(0);
			}
		}
		GRRLIB_Render();
    }
    return 0;
}
int caps2(int buttonswitch){
	char keypressed [5];
	switch( buttonswitch ) {
		case 101: strcpy (keypressed, "!"); break;
		case 102: strcpy (keypressed, "@"); break;
		case 103: strcpy (keypressed, "#"); break;
		case 104: strcpy (keypressed, "$"); break;
		case 105: strcpy (keypressed, "%%"); break;
		case 106: strcpy (keypressed, "^"); break;
		case 107: strcpy (keypressed, "&"); break;
		case 108: strcpy (keypressed, "*"); break;
		case 109: strcpy (keypressed, "("); break;
		case 110: strcpy (keypressed, ")"); break;
		case 111: strcpy (keypressed, "_"); break;
		case 112: strcpy (keypressed, "+"); break;
		case 201: strcpy (keypressed, "Q"); break;
		case 202: strcpy (keypressed, "W"); break;
		case 203: strcpy (keypressed, "E"); break;
		case 204: strcpy (keypressed, "R"); break;
		case 205: strcpy (keypressed, "T"); break;
		case 206: strcpy (keypressed, "Y"); break;
		case 207: strcpy (keypressed, "U"); break;
		case 208: strcpy (keypressed, "I"); break;
		case 209: strcpy (keypressed, "O"); break;
		case 210: strcpy (keypressed, "P"); break;
		case 211: strcpy (keypressed, "{"); break;
		case 212: strcpy (keypressed, "}"); break;
		case 301: strcpy (keypressed, "A"); break;
		case 302: strcpy (keypressed, "S"); break;
		case 303: strcpy (keypressed, "D"); break;
		case 304: strcpy (keypressed, "F"); break;
		case 305: strcpy (keypressed, "G"); break;
		case 306: strcpy (keypressed, "H"); break;
		case 307: strcpy (keypressed, "J"); break;
		case 308: strcpy (keypressed, "K"); break;
		case 309: strcpy (keypressed, "L"); break;
		case 310: strcpy (keypressed, ":"); break;
		case 311: strcpy (keypressed, "\""); break;
		case 312: strcpy (keypressed, "|"); break;
		case 401: strcpy (keypressed, "Z"); break;
		case 402: strcpy (keypressed, "X"); break;
		case 403: strcpy (keypressed, "C"); break;
		case 404: strcpy (keypressed, "V"); break;
		case 405: strcpy (keypressed, "B"); break;
		case 406: strcpy (keypressed, "N"); break;
		case 407: strcpy (keypressed, "M"); break;
		case 408: strcpy (keypressed, "<"); break;
		case 409: strcpy (keypressed, ">"); break;
		case 410: strcpy (keypressed, "?"); break;
		case 411: strcpy (keypressed, "~"); break;
		case 412: strcpy (keypressed, "\n"); break;
	}
	return keypressed;
}
	
int caps1(int buttonswitch){
	char keypressed [5];
	switch( buttonswitch ) {
		case 101: strcpy (keypressed, "1"); break;
		case 102: strcpy (keypressed, "2"); break;
		case 103: strcpy (keypressed, "3"); break;
		case 104: strcpy (keypressed, "4"); break;
		case 105: strcpy (keypressed, "5"); break;
		case 106: strcpy (keypressed, "6"); break;
		case 107: strcpy (keypressed, "7"); break;
		case 108: strcpy (keypressed, "8"); break;
		case 109: strcpy (keypressed, "9"); break;
		case 110: strcpy (keypressed, "0"); break;
		case 111: strcpy (keypressed, "-"); break;
		case 112: strcpy (keypressed, "="); break;
		case 201: strcpy (keypressed, "q"); break;
		case 202: strcpy (keypressed, "w"); break;
		case 203: strcpy (keypressed, "e"); break;
		case 204: strcpy (keypressed, "r"); break;
		case 205: strcpy (keypressed, "t"); break;
		case 206: strcpy (keypressed, "y"); break;
		case 207: strcpy (keypressed, "u"); break;
		case 208: strcpy (keypressed, "i"); break;
		case 209: strcpy (keypressed, "o"); break;
		case 210: strcpy (keypressed, "p"); break;
		case 211: strcpy (keypressed, "["); break;
		case 212: strcpy (keypressed, "]"); break;
		case 301: strcpy (keypressed, "a"); break;
		case 302: strcpy (keypressed, "s"); break;
		case 303: strcpy (keypressed, "d"); break;
		case 304: strcpy (keypressed, "f"); break;
		case 305: strcpy (keypressed, "g"); break;
		case 306: strcpy (keypressed, "h"); break;
		case 307: strcpy (keypressed, "j"); break;
		case 308: strcpy (keypressed, "k"); break;
		case 309: strcpy (keypressed, "l"); break;
		case 310: strcpy (keypressed, ";"); break;
		case 311: strcpy (keypressed, "'"); break;
		case 312: strcpy (keypressed, "\\"); break;
		case 401: strcpy (keypressed, "z"); break;
		case 402: strcpy (keypressed, "x"); break;
		case 403: strcpy (keypressed, "c"); break;
		case 404: strcpy (keypressed, "v"); break;
		case 405: strcpy (keypressed, "b"); break;
		case 406: strcpy (keypressed, "n"); break;
		case 407: strcpy (keypressed, "m"); break;
		case 408: strcpy (keypressed, ","); break;
		case 409: strcpy (keypressed, "."); break;
		case 410: strcpy (keypressed, "/"); break;
		case 411: strcpy (keypressed, "`"); break;
		case 412: strcpy (keypressed, " "); break;
	}
	return keypressed;
}
struct LLNode *initLLNode(char val){
	struct LLNode *temp;
	temp=(struct LLNode *)malloc(sizeof(struct LLNode));
	temp->next=NULL;
	temp->key=val;
	return(temp);
}
